
package org.apache.beehive.controls.system.jdbc;

import java.beans.*;

import java.lang.reflect.Method;
import java.lang.reflect.UndeclaredThrowableException;
import java.util.HashMap;
import java.util.Map;

import org.apache.beehive.controls.api.bean.*;
import org.apache.beehive.controls.api.context.ControlBeanContext;
import org.apache.beehive.controls.api.properties.PropertyKey;
import org.apache.beehive.controls.api.properties.PropertyMap;
import org.apache.beehive.controls.api.versioning.*;

@SuppressWarnings("all")
public class JdbcControlBean
extends org.apache.beehive.controls.runtime.bean.ControlBean
implements org.apache.beehive.controls.system.jdbc.JdbcControl
{
    static final Method _getDataSourceCalendarMethod;
    static final Method _getConnectionMethod;
    static final Method _setDataSourceCalendarMethod;
    
    //
    // This HashMap will map from a Method to the array of names for parameters of the
    // method.  This is necessary because parameter name data isn't carried along in the
    // class file, but if available can enable ease of use by referencing parameters by
    // the declared name (vs. by index).
    //
    // This map should be read-only after its initialization in the static block, hence
    // using a plain HashMap is thread-safe.
    //
    static HashMap<Method, String []> _methodParamMap = new HashMap<Method, String []>();
    
    static
    {
        
        
        try
        {
            _getDataSourceCalendarMethod = org.apache.beehive.controls.system.jdbc.JdbcControl.class.getMethod("getDataSourceCalendar", new Class [] {});
            _methodParamMap.put(_getDataSourceCalendarMethod, new String [] {  });
            _getConnectionMethod = org.apache.beehive.controls.system.jdbc.JdbcControl.class.getMethod("getConnection", new Class [] {});
            _methodParamMap.put(_getConnectionMethod, new String [] {  });
            _setDataSourceCalendarMethod = org.apache.beehive.controls.system.jdbc.JdbcControl.class.getMethod("setDataSourceCalendar", new Class [] {java.util.Calendar.class});
            _methodParamMap.put(_setDataSourceCalendarMethod, new String [] { "cal" });
        }
        catch (NoSuchMethodException __bc_nsme)
        {
            throw new ExceptionInInitializerError(__bc_nsme);
        }
    }
    
    
    
    static
    {
        
    }
    
    
    
    /**
    * This is the public constructor for the class.  A client-defined control ID may
    * be provided.  This ID must be unique within the nesting ControlBeanContext.
    * @param context The containing ControlBeanContext
    * @param id The control identifier (or null to autogenerate a unique value)
    * @param props The initialization Properties for the new instance (or null for defaults)
    */
    public JdbcControlBean(ControlBeanContext context, String id, PropertyMap props)
    {
        this(context, id, props, org.apache.beehive.controls.system.jdbc.JdbcControl.class);
    }
    
    /**
    * This is the public null-arg constructor for this ControlBean.  If a control id
    * is not provided, a unique value will be auto-generated.
    */
    public JdbcControlBean()
    {
        this(null, null, null);
    }
    
    /**
    * This is the protected version that is used by any ControlBean subclass
    */
    protected JdbcControlBean(ControlBeanContext context, String id, PropertyMap props, Class controlClass)
    {
        super(context, id, props, controlClass);
        
    }
    
    
    /**
    * Returns an array of parameter names for the request method, or null if no parameter
    * data is available.
    */
    protected String [] getParameterNames(Method m)
    {
        // Check the local map for operations on this bean type
        if (_methodParamMap.containsKey(m))
        {
            return _methodParamMap.get(m);
        }
        
        // Delegate up if not found locally
        return super.getParameterNames(m);
    }
    
    /**
    * Implements org.apache.beehive.controls.system.jdbc.JdbcControl.getDataSourceCalendar
    */
    public  java.util.Calendar getDataSourceCalendar() 
    {
        Object [] __bc_argArray = new Object[] {  };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.jdbc.JdbcControl __bc_target = (org.apache.beehive.controls.system.jdbc.JdbcControl)ensureControl();
        java.util.Calendar __bc_retval = null;
        
        try
        {
            preInvoke(_getDataSourceCalendarMethod, __bc_argArray);
            
            __bc_retval =
            __bc_target.getDataSourceCalendar()
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getDataSourceCalendarMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements org.apache.beehive.controls.system.jdbc.JdbcControl.getConnection
    */
    public  java.sql.Connection getConnection() throws java.sql.SQLException
    {
        Object [] __bc_argArray = new Object[] {  };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.jdbc.JdbcControl __bc_target = (org.apache.beehive.controls.system.jdbc.JdbcControl)ensureControl();
        java.sql.Connection __bc_retval = null;
        
        try
        {
            preInvoke(_getConnectionMethod, __bc_argArray);
            
            __bc_retval =
            __bc_target.getConnection()
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            else if (__bc_t instanceof java.sql.SQLException) throw (java.sql.SQLException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = __bc_retval;
            postInvoke(_getConnectionMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
        return __bc_retval;
    }
    
    /**
    * Implements org.apache.beehive.controls.system.jdbc.JdbcControl.setDataSourceCalendar
    */
    public  void setDataSourceCalendar(java.util.Calendar cal) 
    {
        Object [] __bc_argArray = new Object[] { cal };
        Throwable __bc_thrown = null;
        org.apache.beehive.controls.system.jdbc.JdbcControl __bc_target = (org.apache.beehive.controls.system.jdbc.JdbcControl)ensureControl();
        
        try
        {
            preInvoke(_setDataSourceCalendarMethod, __bc_argArray);
            
            __bc_target.setDataSourceCalendar(cal)
            ;
        }
        catch (Throwable __bc_t)
        {
            //
            // All exceptions are caught here, so postInvoke processing has visibility into
            // the exception status.  Errors, RuntimExceptions, or declared checked exceptions will
            // be rethrown.
            //
            __bc_thrown = __bc_t;
            
            if (__bc_t instanceof Error) throw (Error)__bc_t;
            else if (__bc_t instanceof RuntimeException) throw (RuntimeException)__bc_t;
            
            throw new UndeclaredThrowableException(__bc_t);
        }
        finally
        {
            Object __bc_rv = null;
            postInvoke(_setDataSourceCalendarMethod, __bc_argArray, __bc_rv, __bc_thrown);
        }
    }
    
    
    /**
    * A PropertyKey that can be used to access the controlImplementation property of the
    * BaseProperties PropertySet
    */
    public static final PropertyKey ControlImplementationKey = new PropertyKey(org.apache.beehive.controls.api.properties.BaseProperties.class, "controlImplementation");
    
    public synchronized void setControlImplementation(java.lang.String value)
    {
        
        setControlProperty(ControlImplementationKey, value);
    }
    
    public java.lang.String getControlImplementation()
    {
        return (java.lang.String)getControlProperty(ControlImplementationKey);
    }
    
    /**
    * A PropertyKey that can be used to access the jndiName property of the
    * ConnectionDataSource PropertySet
    */
    public static final PropertyKey ConnectionDataSourceJndiNameKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.ConnectionDataSource.class, "jndiName");
    
    public synchronized void setConnectionDataSourceJndiName(java.lang.String value)
    {
        
        setControlProperty(ConnectionDataSourceJndiNameKey, value);
    }
    
    public java.lang.String getConnectionDataSourceJndiName()
    {
        return (java.lang.String)getControlProperty(ConnectionDataSourceJndiNameKey);
    }
    
    /**
    * A PropertyKey that can be used to access the jndiContextFactory property of the
    * ConnectionDataSource PropertySet
    */
    public static final PropertyKey ConnectionDataSourceJndiContextFactoryKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.ConnectionDataSource.class, "jndiContextFactory");
    
    public synchronized void setConnectionDataSourceJndiContextFactory(java.lang.Class<? extends org.apache.beehive.controls.system.jdbc.JdbcControl.JndiContextFactory> value)
    {
        
        setControlProperty(ConnectionDataSourceJndiContextFactoryKey, value);
    }
    
    public java.lang.Class<? extends org.apache.beehive.controls.system.jdbc.JdbcControl.JndiContextFactory> getConnectionDataSourceJndiContextFactory()
    {
        return (java.lang.Class<? extends org.apache.beehive.controls.system.jdbc.JdbcControl.JndiContextFactory>)getControlProperty(ConnectionDataSourceJndiContextFactoryKey);
    }
    
    /**
    * A PropertyKey that can be used to access the databaseDriverClass property of the
    * ConnectionDriver PropertySet
    */
    public static final PropertyKey ConnectionDriverDatabaseDriverClassKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.ConnectionDriver.class, "databaseDriverClass");
    
    public synchronized void setConnectionDriverDatabaseDriverClass(java.lang.String value)
    {
        
        setControlProperty(ConnectionDriverDatabaseDriverClassKey, value);
    }
    
    public java.lang.String getConnectionDriverDatabaseDriverClass()
    {
        return (java.lang.String)getControlProperty(ConnectionDriverDatabaseDriverClassKey);
    }
    
    /**
    * A PropertyKey that can be used to access the databaseURL property of the
    * ConnectionDriver PropertySet
    */
    public static final PropertyKey ConnectionDriverDatabaseURLKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.ConnectionDriver.class, "databaseURL");
    
    public synchronized void setConnectionDriverDatabaseURL(java.lang.String value)
    {
        
        setControlProperty(ConnectionDriverDatabaseURLKey, value);
    }
    
    public java.lang.String getConnectionDriverDatabaseURL()
    {
        return (java.lang.String)getControlProperty(ConnectionDriverDatabaseURLKey);
    }
    
    /**
    * A PropertyKey that can be used to access the userName property of the
    * ConnectionDriver PropertySet
    */
    public static final PropertyKey ConnectionDriverUserNameKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.ConnectionDriver.class, "userName");
    
    public synchronized void setConnectionDriverUserName(java.lang.String value)
    {
        
        setControlProperty(ConnectionDriverUserNameKey, value);
    }
    
    public java.lang.String getConnectionDriverUserName()
    {
        return (java.lang.String)getControlProperty(ConnectionDriverUserNameKey);
    }
    
    /**
    * A PropertyKey that can be used to access the password property of the
    * ConnectionDriver PropertySet
    */
    public static final PropertyKey ConnectionDriverPasswordKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.ConnectionDriver.class, "password");
    
    public synchronized void setConnectionDriverPassword(java.lang.String value)
    {
        
        setControlProperty(ConnectionDriverPasswordKey, value);
    }
    
    public java.lang.String getConnectionDriverPassword()
    {
        return (java.lang.String)getControlProperty(ConnectionDriverPasswordKey);
    }
    
    /**
    * A PropertyKey that can be used to access the properties property of the
    * ConnectionDriver PropertySet
    */
    public static final PropertyKey ConnectionDriverPropertiesKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.ConnectionDriver.class, "properties");
    
    public synchronized void setConnectionDriverProperties(java.lang.String value)
    {
        
        setControlProperty(ConnectionDriverPropertiesKey, value);
    }
    
    public java.lang.String getConnectionDriverProperties()
    {
        return (java.lang.String)getControlProperty(ConnectionDriverPropertiesKey);
    }
    
    /**
    * A PropertyKey that can be used to access the readOnly property of the
    * ConnectionOptions PropertySet
    */
    public static final PropertyKey ConnectionOptionsReadOnlyKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.ConnectionOptions.class, "readOnly");
    
    public synchronized void setConnectionOptionsReadOnly(boolean value)
    {
        
        setControlProperty(ConnectionOptionsReadOnlyKey, value);
    }
    
    public boolean isConnectionOptionsReadOnly()
    {
        return (Boolean)getControlProperty(ConnectionOptionsReadOnlyKey);
    }
    
    /**
    * A PropertyKey that can be used to access the resultSetHoldability property of the
    * ConnectionOptions PropertySet
    */
    public static final PropertyKey ConnectionOptionsResultSetHoldabilityKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.ConnectionOptions.class, "resultSetHoldability");
    
    public synchronized void setConnectionOptionsResultSetHoldability(org.apache.beehive.controls.system.jdbc.JdbcControl.HoldabilityType value)
    {
        
        setControlProperty(ConnectionOptionsResultSetHoldabilityKey, value);
    }
    
    public org.apache.beehive.controls.system.jdbc.JdbcControl.HoldabilityType getConnectionOptionsResultSetHoldability()
    {
        return (org.apache.beehive.controls.system.jdbc.JdbcControl.HoldabilityType)getControlProperty(ConnectionOptionsResultSetHoldabilityKey);
    }
    
    /**
    * A PropertyKey that can be used to access the typeMappers property of the
    * ConnectionOptions PropertySet
    */
    public static final PropertyKey ConnectionOptionsTypeMappersKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.ConnectionOptions.class, "typeMappers");
    
    public synchronized void setConnectionOptionsTypeMappers(org.apache.beehive.controls.system.jdbc.JdbcControl.TypeMapper[] value)
    {
        
        setControlProperty(ConnectionOptionsTypeMappersKey, value);
    }
    
    public org.apache.beehive.controls.system.jdbc.JdbcControl.TypeMapper[] getConnectionOptionsTypeMappers()
    {
        return (org.apache.beehive.controls.system.jdbc.JdbcControl.TypeMapper[])getControlProperty(ConnectionOptionsTypeMappersKey);
    }
    
    /**
    * A PropertyKey that can be used to access the UDTName property of the
    * TypeMapper PropertySet
    */
    public static final PropertyKey TypeMapperUDTNameKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.TypeMapper.class, "UDTName");
    
    public synchronized void setTypeMapperUDTName(java.lang.String value)
    {
        
        setControlProperty(TypeMapperUDTNameKey, value);
    }
    
    public java.lang.String getTypeMapperUDTName()
    {
        return (java.lang.String)getControlProperty(TypeMapperUDTNameKey);
    }
    
    /**
    * A PropertyKey that can be used to access the mapperClass property of the
    * TypeMapper PropertySet
    */
    public static final PropertyKey TypeMapperMapperClassKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.TypeMapper.class, "mapperClass");
    
    public synchronized void setTypeMapperMapperClass(java.lang.Class<? extends java.sql.SQLData> value)
    {
        
        setControlProperty(TypeMapperMapperClassKey, value);
    }
    
    public java.lang.Class<? extends java.sql.SQLData> getTypeMapperMapperClass()
    {
        return (java.lang.Class<? extends java.sql.SQLData>)getControlProperty(TypeMapperMapperClassKey);
    }
    
    /**
    * A PropertyKey that can be used to access the statement property of the
    * SQL PropertySet
    */
    public static final PropertyKey SQLStatementKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.SQL.class, "statement");
    
    public synchronized void setSQLStatement(java.lang.String value)
    {
        
        setControlProperty(SQLStatementKey, value);
    }
    
    public java.lang.String getSQLStatement()
    {
        return (java.lang.String)getControlProperty(SQLStatementKey);
    }
    
    /**
    * A PropertyKey that can be used to access the arrayMaxLength property of the
    * SQL PropertySet
    */
    public static final PropertyKey SQLArrayMaxLengthKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.SQL.class, "arrayMaxLength");
    
    public synchronized void setSQLArrayMaxLength(int value)
    {
        
        setControlProperty(SQLArrayMaxLengthKey, value);
    }
    
    public int getSQLArrayMaxLength()
    {
        return (Integer)getControlProperty(SQLArrayMaxLengthKey);
    }
    
    /**
    * A PropertyKey that can be used to access the maxRows property of the
    * SQL PropertySet
    */
    public static final PropertyKey SQLMaxRowsKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.SQL.class, "maxRows");
    
    public synchronized void setSQLMaxRows(int value)
    {
        
        setControlProperty(SQLMaxRowsKey, value);
    }
    
    public int getSQLMaxRows()
    {
        return (Integer)getControlProperty(SQLMaxRowsKey);
    }
    
    /**
    * A PropertyKey that can be used to access the batchUpdate property of the
    * SQL PropertySet
    */
    public static final PropertyKey SQLBatchUpdateKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.SQL.class, "batchUpdate");
    
    public synchronized void setSQLBatchUpdate(boolean value)
    {
        
        setControlProperty(SQLBatchUpdateKey, value);
    }
    
    public boolean isSQLBatchUpdate()
    {
        return (Boolean)getControlProperty(SQLBatchUpdateKey);
    }
    
    /**
    * A PropertyKey that can be used to access the fetchSize property of the
    * SQL PropertySet
    */
    public static final PropertyKey SQLFetchSizeKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.SQL.class, "fetchSize");
    
    public synchronized void setSQLFetchSize(int value)
    {
        
        setControlProperty(SQLFetchSizeKey, value);
    }
    
    public int getSQLFetchSize()
    {
        return (Integer)getControlProperty(SQLFetchSizeKey);
    }
    
    /**
    * A PropertyKey that can be used to access the fetchDirection property of the
    * SQL PropertySet
    */
    public static final PropertyKey SQLFetchDirectionKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.SQL.class, "fetchDirection");
    
    public synchronized void setSQLFetchDirection(org.apache.beehive.controls.system.jdbc.JdbcControl.FetchDirection value)
    {
        
        setControlProperty(SQLFetchDirectionKey, value);
    }
    
    public org.apache.beehive.controls.system.jdbc.JdbcControl.FetchDirection getSQLFetchDirection()
    {
        return (org.apache.beehive.controls.system.jdbc.JdbcControl.FetchDirection)getControlProperty(SQLFetchDirectionKey);
    }
    
    /**
    * A PropertyKey that can be used to access the getGeneratedKeys property of the
    * SQL PropertySet
    */
    public static final PropertyKey SQLGetGeneratedKeysKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.SQL.class, "getGeneratedKeys");
    
    public synchronized void setSQLGetGeneratedKeys(boolean value)
    {
        
        setControlProperty(SQLGetGeneratedKeysKey, value);
    }
    
    public boolean isSQLGetGeneratedKeys()
    {
        return (Boolean)getControlProperty(SQLGetGeneratedKeysKey);
    }
    
    /**
    * A PropertyKey that can be used to access the generatedKeyColumnNames property of the
    * SQL PropertySet
    */
    public static final PropertyKey SQLGeneratedKeyColumnNamesKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.SQL.class, "generatedKeyColumnNames");
    
    public synchronized void setSQLGeneratedKeyColumnNames(java.lang.String[] value)
    {
        
        setControlProperty(SQLGeneratedKeyColumnNamesKey, value);
    }
    
    public java.lang.String[] getSQLGeneratedKeyColumnNames()
    {
        return (java.lang.String[])getControlProperty(SQLGeneratedKeyColumnNamesKey);
    }
    
    /**
    * A PropertyKey that can be used to access the generatedKeyColumnIndexes property of the
    * SQL PropertySet
    */
    public static final PropertyKey SQLGeneratedKeyColumnIndexesKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.SQL.class, "generatedKeyColumnIndexes");
    
    public synchronized void setSQLGeneratedKeyColumnIndexes(int[] value)
    {
        
        setControlProperty(SQLGeneratedKeyColumnIndexesKey, value);
    }
    
    public int[] getSQLGeneratedKeyColumnIndexes()
    {
        return (int[])getControlProperty(SQLGeneratedKeyColumnIndexesKey);
    }
    
    /**
    * A PropertyKey that can be used to access the resultSetHoldabilityOverride property of the
    * SQL PropertySet
    */
    public static final PropertyKey SQLResultSetHoldabilityOverrideKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.SQL.class, "resultSetHoldabilityOverride");
    
    public synchronized void setSQLResultSetHoldabilityOverride(org.apache.beehive.controls.system.jdbc.JdbcControl.HoldabilityType value)
    {
        
        setControlProperty(SQLResultSetHoldabilityOverrideKey, value);
    }
    
    public org.apache.beehive.controls.system.jdbc.JdbcControl.HoldabilityType getSQLResultSetHoldabilityOverride()
    {
        return (org.apache.beehive.controls.system.jdbc.JdbcControl.HoldabilityType)getControlProperty(SQLResultSetHoldabilityOverrideKey);
    }
    
    /**
    * A PropertyKey that can be used to access the typeMappersOverride property of the
    * SQL PropertySet
    */
    public static final PropertyKey SQLTypeMappersOverrideKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.SQL.class, "typeMappersOverride");
    
    public synchronized void setSQLTypeMappersOverride(org.apache.beehive.controls.system.jdbc.JdbcControl.TypeMapper[] value)
    {
        
        setControlProperty(SQLTypeMappersOverrideKey, value);
    }
    
    public org.apache.beehive.controls.system.jdbc.JdbcControl.TypeMapper[] getSQLTypeMappersOverride()
    {
        return (org.apache.beehive.controls.system.jdbc.JdbcControl.TypeMapper[])getControlProperty(SQLTypeMappersOverrideKey);
    }
    
    /**
    * A PropertyKey that can be used to access the iteratorElementType property of the
    * SQL PropertySet
    */
    public static final PropertyKey SQLIteratorElementTypeKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.SQL.class, "iteratorElementType");
    
    public synchronized void setSQLIteratorElementType(java.lang.Class value)
    {
        
        setControlProperty(SQLIteratorElementTypeKey, value);
    }
    
    public java.lang.Class getSQLIteratorElementType()
    {
        return (java.lang.Class)getControlProperty(SQLIteratorElementTypeKey);
    }
    
    /**
    * A PropertyKey that can be used to access the resultSetMapper property of the
    * SQL PropertySet
    */
    public static final PropertyKey SQLResultSetMapperKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.SQL.class, "resultSetMapper");
    
    public synchronized void setSQLResultSetMapper(java.lang.Class value)
    {
        
        setControlProperty(SQLResultSetMapperKey, value);
    }
    
    public java.lang.Class getSQLResultSetMapper()
    {
        return (java.lang.Class)getControlProperty(SQLResultSetMapperKey);
    }
    
    /**
    * A PropertyKey that can be used to access the scrollableResultSet property of the
    * SQL PropertySet
    */
    public static final PropertyKey SQLScrollableResultSetKey = new PropertyKey(org.apache.beehive.controls.system.jdbc.JdbcControl.SQL.class, "scrollableResultSet");
    
    public synchronized void setSQLScrollableResultSet(org.apache.beehive.controls.system.jdbc.JdbcControl.ScrollType value)
    {
        
        setControlProperty(SQLScrollableResultSetKey, value);
    }
    
    public org.apache.beehive.controls.system.jdbc.JdbcControl.ScrollType getSQLScrollableResultSet()
    {
        return (org.apache.beehive.controls.system.jdbc.JdbcControl.ScrollType)getControlProperty(SQLScrollableResultSetKey);
    }
    
    
    
    
    
    /**
    * The _annotCache maintains a lookup cache from AnnotatedElements to an associated
    * PropertyMap.  This enables these maps to be shared across multiple beans.
    */
    static private HashMap __bc_annotCache = new HashMap();
    
    protected Map getPropertyMapCache() { return __bc_annotCache; }
    
    private static final long serialVersionUID = 1L;
}
